## wesnoth-1.18 1.18.5

=== CMakeLists.txt ===
﻿# set minimum version
cmake_minimum_required(VERSION 3.14)

project(wesnoth)

include(CheckCXXCompilerFlag)
include(CTest)

# use our own version of FindBoost.cmake and other Find* scripts
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# function to remove a flag from a variable
function(RemoveFlag VAR SCOPE FLAG DOCSTRING)
	if(NOT "${${VAR}}" STREQUAL "")
		MESSAGE("Removing ${FLAG} flag from ${VAR}")
		separate_arguments(${VAR})
		list(REMOVE_ITEM ${VAR} ${FLAG})
		string(REPLACE ";" " " ${VAR} "${${VAR}}")

		if("${SCOPE}" STREQUAL "CACHE")
			set(${VAR} "${${VAR}}" CACHE STRING "${DOCSTRING}" FORCE)
		elseif("${SCOPE}" STREQUAL "SCRIPT")
			set(${VAR} "${${VAR}}" PARENT_SCOPE)
		endif()
	endif()
endfunction()

#
# Options
#

# Adhere to GNU filesystem layout conventions
include(GNUInstallDirs)

#Path options
set(DATADIRNAME "wesnoth" CACHE STRING "change the name of the directory for the read-only architecture-independent game data")
set(EXECUTABLE_OUTPUT_PATH "${CMAKE_BINARY_DIR}" CACHE STRING "change the dir where binaries are placed right at compile time")
set(LOCALEDIR "translations" CACHE STRING "change the name of the locale data directory to a non-default name")
set(PREFERENCES_DIR "" CACHE STRING "Use a non-default preferences directory (.wesnoth on unix)")
set(DEFAULT_PREFS_FILE "" CACHE STRING "Set system wide preferences file")

#server options
set(SERVER_UID "" CACHE STRING "User id of the user who runs wesnothd")
set(SERVER_GID "" CACHE STRING "Group id of the user who runs wesnothd")
set(FIFO_DIR "/var/run/wesnothd" CACHE STRING "Directory for the wesnothd fifo socket file")

#build options
option(ENABLE_GAME "Enable compilation of the game" ON)
option(ENABLE_CAMPAIGN_SERVER "Enable compilation of campaign(add-ons) server")
option(ENABLE_SERVER "Enable compilation of MP server" ON)
option(ENABLE_MYSQL "Enable building MP/add-ons servers with mysql support" OFF)
option(ENABLE_TESTS "Build unit tests")
option(ENABLE_NLS "Enable building of translations" ${ENABLE_GAME})

set(BOOST_VERSION "1.67")

if(NOT WIN32)
	set(Lua_FIND_VERSION_MAJOR 5)
	set(Lua_FIND_VERSION_MINOR 4)
	option(ENABLE_SYSTEM_LUA "Enable use of system Lua ${Lua_FIND_VERSION_MAJOR}.${Lua_FIND_VERSION_MINOR} (compiled as C++)" OFF)
endif()
if(ENABLE_SYSTEM_LUA)
	set(Lua_FIND_VERSION_EXACT ON)
	set(Lua_FIND_VERSION_COUNT 2)
	include(FindLua)
	if(NOT LUA_FOUND)
		message(FATAL_ERROR "Lua ${Lua_FIND_VERSION_MAJOR}.${Lua_FIND_VERSION_MINOR} C++ not found. Try setting 'LUA_DIR'.")
	endif()
else()
	if(NOT EXISTS "${CMAKE_SOURCE_DIR}/src/modules/lua/.git")
		message(FATAL_ERROR "Lua submodule does not exist. You must run 'git submodule update --init --recursive' to initialize it.")
	else()
		message("-- Lua submodule found.")
	endif()
endif()

# set what std version to use
if(NOT CXX_STD)
	set(CXX_STD "17")
endif()
set(CMAKE_CXX_STANDARD ${CXX_STD})
# make sure to force using it
set(CMAKE_CXX_STANDARD_REQUIRED ON)
# forbid defaulting to gnu++NN instead of c++NN
set(CMAKE_CXX_EXTENSIONS OFF)

find_package(OpenSSL 1.0 REQUIRED)

if(APPLE)
	find_library(APPKIT_LIBRARY AppKit REQUIRED)
	find_library(FOUNDATION_LIBRARY Foundation REQUIRED)
	find_library(IOKIT_LIBRARY IOKit REQUIRED)
	find_library(SECURITY_LIBRARY Security REQUIRED)
endif()

find_package(Boost ${BOOST_VERSION} REQUIRED COMPONENTS iostreams program_options regex system thread random coroutine locale filesystem graph)
find_package(ICU REQUIRED COMPONENTS data i18n uc)

# no, gettext executables are not required when NLS is deactivated
find_package(Gettext)
find_package(Python)

find_package(X11)

if(NOT WIN32 AND NOT ENABLE_SYSTEM_LUA)
	# Use the safer `mkstemp' instead of `tmpnam' on POSIX systems.
	add_definitions(-DLUA_USE_POSIX)
endif()

#check for some compiler/arch specific things and export defines accordingly...
include(SearchForStuff)

# if no build type is specified, it can happen that the game is built without
# optimization (c.f. bug #23445), work around this by enforcing "release" type
# if nothing was selected
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
	message("No build type specified, defaulting to Release")
endif()

if(NOT DEFINED ENABLE_DISPLAY_REVISION)
	# can't run the shell script on windows
	if(NOT WIN32)
		# Test whether the code is used in a repository if not autorevision will
		# fail and should be disabled by default. If inside a repository enable
		# the display of revision numbers by default.
		execute_process(
			COMMAND ${CMAKE_SOURCE_DIR}/utils/autorevision.sh -t h > ${CMAKE_CURRENT_BINARY_DIR}/revision.dummy
			WORKING_DIRECTORY
				${CMAKE_SOURCE_DIR}
			OUTPUT_VARIABLE
				ENABLE_DISPLAY_REVISION_TEST_OUTPUT
			ERROR_VARIABLE
				ENABLE_DISPLAY_REVISION_TEST_ERRNO
		)

		if("${ENABLE_DISPLAY_REVISION_TEST_ERRNO}" STREQUAL "")
			set(DEFAULT_ENABLE_DISPLAY_REVISION true)
		else()
			set(DEFAULT_ENABLE_DISPLAY_REVISION false)
		endif()

		unset(ENABLE_DISPLAY_REVISION_TEST_OUTPUT)
		unset(ENABLE_DISPLAY_REVISION_TEST_ERRNO)
	else()
		set(DEFAULT_ENABLE_DISPLAY_REVISION false)
	endif()
endif()

option(
	ENABLE_DISPLAY_REVISION
	"Enable the display of the revision number in the game, only enable it when in a checkout"
	${DEFAULT_ENABLE_DISPLAY_REVISION}
)

if(UNIX AND NOT APPLE AND NOT CYGWIN)
	option(ENABLE_DESKTOP_ENTRY "enable installation of desktop entry files" ON)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	option(ENABLE_APPDATA_FILE "enable installation of an appdata file for appstream" ON)
endif()

option(HARDEN "Whether to enable options to harden the executables" ON)
option(ENABLE_STRICT_COMPILATION "Sets the strict compilation mode" OFF)
option(ENABLE_PEDANTIC_COMPILATION "Sets the pedantic compilation mode" OFF)
option(ENABLE_DEBUG_WINDOW_LAYOUT "Add the debug option to allow the generation of debug layout files in dot format" OFF)
option(ENABLE_DESIGN_DOCUMENTS "Enables the generation of design documents, and has additional dependencies" OFF)
option(ENABLE_LTO "Sets Link Time Optimization for Release builds" OFF)
option(GLIBCXX_ASSERTIONS "Whether to define _GLIBCXX_ASSERTIONS" OFF)
option(GLIBCXX_DEBUG "Whether to define _GLIBCXX_DEBUG and _GLIBCXX_DEBUG_PEDANTIC. Requires a version of Boost's program_options that's compiled with __GLIBCXX_DEBUG too." OFF)
option(ENABLE_POT_UPDATE_TARGET "Enables the tools to update the pot files and manuals. This target has extra dependencies." OFF)
option(FORCE_COLOR_OUTPUT "Always produce ANSI-colored output (GNU/Clang only)." FALSE)

if(UNIX AND NOT APPLE AND NOT CYGWIN)
	option(ENABLE_NOTIFICATIONS "Enable Window manager notification messages" ON)
endif()

set(BINARY_SUFFIX "" CACHE STRING "Suffix behind all binaries")
set(BINARY_PREFIX "" CACHE STRING "Prefix in front of all binaries")

#
# Handle options (set paths/definitions/etc...)
#

### Set the environment compiler flags.

if(NOT MSVC)
	if(NOT DEFINED CXX_FLAGS_USER)

		MESSAGE(STATUS "Environment compiler flags set to »${CXX_FLAGS_USER}«")
		set(CXX_FLAGS_USER
			"$ENV{CXXFLAGS}"
			CACHE
			STRING
			"The CXXFLAGS environment variable used for the initial generation."
			FORCE
		)

	endif()

	set(COMPILER_FLAGS "-Wall -Wextra -Werror=non-virtual-dtor -Wno-unused-local-typedefs -Wno-maybe-uninitialized -Wold-style-cast -Wtrampolines")

	if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
		set(COMPILER_FLAGS "${COMPILER_FLAGS} -Qunused-arguments -Wno-unknown-warning-option -Wmismatched-tags -Wno-conditional-uninitialized -Wno-unused-lambda-capture")
	endif()

	if(CMAKE_CXX_COMPILER_ID MATCHES "GNU"
			AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 13
			AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 14)
		# GCC-13 added this new warning, and included it in -Wextra,
		# however in GCC-13 it has a lot of false positives.
		#
		# It's likely to generate false postives with GCC-14 too, but
		# I'm using a narrow version check as GCC-14 is still in dev.
		# See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=110075
		set(COMPILER_FLAGS "${COMPILER_FLAGS} -Wno-dangling-reference")
	endif()

### Set strict compiler flags.

	if(ENABLE_STRICT_COMPILATION)
		set(COMPILER_FLAGS "${COMPILER_FLAGS} -Werror")
	endif()

### Set pedantic compiler flags.

	if(ENABLE_PEDANTIC_COMPILATION)

		set(CXX_FLAGS_PEDANTIC_COMPILATION "-Wlogical-op -Wmissing-declarations -Wredundant-decls -Wctor-dtor-privacy -Wdouble-promotion -Wuseless-cast -Wnoexcept")

		if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
			set(CXX_FLAGS_PEDANTIC_COMPILATION "${CXX_FLAGS_PEDANTIC_COMPILATION} -Wdocumentation -Wno-documentation-deprecated-sync")
		endif()

		set(COMPILER_FLAGS "${COMPILER_FLAGS} ${CXX_FLAGS_PEDANTIC_COMPILATION}")

	endif()

# check for sanitizer options
	if(SANITIZE)
		set(COMPILER_FLAGS "${COMPILER_FLAGS} -fsanitize=${SANITIZE}")
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=${SANITIZE}")
		# manually disable some optimizations to get better stacktraces if sanitizers are used
		set(COMPILER_FLAGS "${COMPILER_FLAGS} -fno-omit-frame-pointer -fno-optimize-sibling-calls")
	endif()

### Force colour output (for example for Ninja, or piped CI)

	if(FORCE_COLOR_OUTPUT)
		if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
			set(COMPILER_FLAGS "${COMPILER_FLAGS} -fdiagnostics-color=always")
		elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
			set(COMPILER_FLAGS "${COMPILER_FLAGS} -fcolor-diagnostics")
		endif()
	endif()

### Set the final compiler flags.

	set(COMPILER_FLAGS "${COMPILER_FLAGS} ${CXX_FLAGS_USER}")

	if(NOT "${CMAKE_CXX_FLAGS}" STREQUAL "${COMPILER_FLAGS}")
		MESSAGE(STATUS "CMake compiler flags set to »${COMPILER_FLAGS}«")
		set(CMAKE_CXX_FLAGS
			"${COMPILER_FLAGS}"
			CACHE
			STRING
			"Global flags used by the CXX compiler during all builds."
			FORCE
		)
	endif()

# #
# Determine optimization level
# #

	if(NOT OPT)
		if(PROFILER STREQUAL "perf")
			set(CMAKE_CXX_FLAGS_RELEASE "-Og")
			set(CMAKE_C_FLAGS_RELEASE "-Og")
		else()
			set(CMAKE_CXX_FLAGS_RELEASE "-O3")
			set(CMAKE_C_FLAGS_RELEASE "-O3")
		endif()
	else()
		set(CMAKE_CXX_FLAGS_RELEASE "${OPT}")
		set(CMAKE_C_FLAGS_RELEASE "${OPT}")

		set(CMAKE_CXX_FLAGS_DEBUG "${OPT}")
		set(CMAKE_C_FLAGS_DEBUG "${OPT}")
	endif()

# check for hardening options
	if(HARDEN)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -fstack-protector-strong")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIE -fstack-protector-strong")

		if(APPLE)
			set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fPIE -Wl,-pie")
		elseif(WIN32 AND MINGW)
			set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fPIE -pie")
		else()
			set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fPIE -pie -Wl,-z,relro,-z,now")
		endif()

		if(NOT CMAKE_CXX_FLAGS_DEBUG STREQUAL "-O0")
			add_definitions(-D_FORTIFY_SOURCE=2)
		endif()
	endif()

	if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
		set(CMAKE_EXE_LINKER_FLAGS "-lstdc++ -lm ${CMAKE_EXE_LINKER_FLAGS}")
	endif()

	add_definitions(-DWESNOTH_PATH="${CMAKE_INSTALL_FULL_DATADIR}/${DATADIRNAME}")

	if(X11_FOUND)
		add_definitions(-D_X11)
	endif()

	add_definitions(-DLOCALEDIR="${LOCALEDIR}")

# -rdynamic is automatically added, but we don't need it, and it increases the executable size
	RemoveFlag(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS SCRIPT "-rdynamic" "")
	RemoveFlag(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS SCRIPT "-rdynamic" "")

# -DNDEBUG is automatically added to all release build types, so manually remove this define from the related variables
	RemoveFlag(CMAKE_CXX_FLAGS_RELWITHDEBINFO CACHE "-DNDEBUG" "Default C++ flags for RelWithDebInfo")
	RemoveFlag(CMAKE_C_FLAGS_RELWITHDEBINFO CACHE "-DNDEBUG" "Default C flags for RelWithDebInfo")
	RemoveFlag(CMAKE_CXX_FLAGS_MINSIZEREL CACHE "-DNDEBUG" "Default C++ flags for MinSizeRel")
	RemoveFlag(CMAKE_C_FLAGS_MINSIZEREL CACHE "-DNDEBUG" "Default C flags for MinSizeRel")

# #
# Start determining options for Release build
# #

# reset the base Release build option

=== po/CMakeLists.txt ===
############ Settings. ###########
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM true)

# The normal domains use cfg, cpp, lua, py files.
set(NORMAL_DOMAINS
	wesnoth
	wesnoth-anl
	wesnoth-did
	wesnoth-dm
	wesnoth-dw
	wesnoth-editor
	wesnoth-ei
	wesnoth-help
	wesnoth-httt
	wesnoth-l
	wesnoth-lib
	wesnoth-low
	wesnoth-multiplayer
	wesnoth-nr
	wesnoth-sof
	wesnoth-sota
	wesnoth-sotbe
	wesnoth-tb
	wesnoth-thot
	wesnoth-tools
	wesnoth-trow
	wesnoth-tsg
	wesnoth-tutorial
	wesnoth-units
	wesnoth-utbs
	wesnoth-wc
	wesnoth-wof
)

# All available domains.
set(DOMAINS
	${NORMAL_DOMAINS}
	wesnoth-manpages
	wesnoth-manual
)

# If a source file has not GETTEXT_DOMAIN it belongs to this domain.
set(DEFAULT_DOMAIN wesnoth)

set(WMLXGETTEXT ${PROJECT_SOURCE_DIR}/data/tools/wmlxgettext)

############ pot update. ###########

if(ENABLE_POT_UPDATE_TARGET)

	# The variable pot-update-SRC accumulates a list of the dummy-targets
	# declared in the following loops. Depending on it will cause all of the
	# custom commands to run.

	foreach(DOMAIN ${NORMAL_DOMAINS})

		# Update the source file dependencies.
		include(update_pot_source_dependencies)

		# Generate pot file for C++ strings.
		add_custom_command(
			# misses bug address
			OUTPUT ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.cpp.pot
			# create the pot file make sure we always get output.
			COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} ${GETTEXT_XGETTEXT_OPTIONS}
					--files-from=${PROJECT_SOURCE_DIR}/po/${DOMAIN}/POTFILES_CPP.in
					--output=${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.cpp.pot
			# replace the chartype
			COMMAND sed -i
				s/charset=CHARSET/charset=UTF-8/
				${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.cpp.pot
			DEPENDS ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/POTFILES_CPP.in
			WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
			COMMENT "pot-update [${DOMAIN}]: Generating source pot file."
		)

		# Generate pot file for Python strings.
		add_custom_command(
			OUTPUT ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.py.pot
			# create the pot file make sure we always get output.
			COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} ${GETTEXT_XGETTEXT_OPTIONS}
					--language=Python
					--files-from=${PROJECT_SOURCE_DIR}/po/${DOMAIN}/POTFILES_PY.in
					--output=${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.py.pot
			# replace the chartype
			COMMAND sed -i
				s/charset=CHARSET/charset=UTF-8/
				${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.py.pot
			DEPENDS ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/POTFILES_PY.in
			WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
			COMMENT "pot-update [${DOMAIN}]: Generating python pot file."
		)
		# Generate pot file for WML/Lua strings.
		add_custom_command(
			OUTPUT ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.wml.pot

			COMMAND ${Python_EXECUTABLE} ${WMLXGETTEXT}
				--force-po
				--domain=${DOMAIN}
				`cd ${PROJECT_SOURCE_DIR} &&
					sh ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/FINDCFG`
					-o ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.wml.pot
			DEPENDS ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/FINDCFG
			WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
			COMMENT "pot-update [${DOMAIN}]: Generating wml pot file."
		)

		# Merge pot files
		add_custom_command(
			# The old function checked for differences in the time in the header see
			# what we need to do with it.
			OUTPUT ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.pot

			COMMAND ${GETTEXT_MSGCAT_EXECUTABLE}
				--sort-by-file
					 ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.cpp.pot
					 ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.py.pot
					 ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.wml.pot
				--output ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.pot

			COMMAND ${CMAKE_COMMAND} -E remove
					 ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.cpp.pot
					 ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.py.pot
					 ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.wml.pot

			WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
			DEPENDS
					${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.cpp.pot
					${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.py.pot
					${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.wml.pot
			COMMENT "pot-update [${DOMAIN}]: Generating pot file."
		)

		# Update / generate the po files for all languages
		foreach(LINGUA ${LINGUAS})

			### Generate new po file.

			# For some reason CMake is rather happy to delete the po file in
			# some cases. Too avoid that problem only generate the init rule
			# if the po file doesn't exist. The case where a po file used to
			# exist and no longer exists should never occur

			if(NOT EXISTS ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${LINGUA}.po)
				add_custom_command(
					OUTPUT ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${LINGUA}.po
					COMMAND ${GETTEXT_MSGINIT_EXECUTABLE}
							--no-translator
							--input=${DOMAIN}.pot
							--output-file=${LINGUA}.po
							--locale=${LINGUA}
					WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po/${DOMAIN}
					DEPENDS
						${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.pot
					COMMENT
						"pot-update [${DOMAIN}-${LINGUA}]: Initialized po file."
				)
			endif(NOT EXISTS ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${LINGUA}.po)

			### Update existing po file.
			add_custom_command(
				# The pot-update depends on a dummy file which we promise to
				# make. We don't make this dummy file but the pot-update
				# still works.
				OUTPUT ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${LINGUA}.po.dummy
				COMMAND ${GETTEXT_MSGMERGE_EXECUTABLE}
						--backup=none
						--previous
						-U ${LINGUA}.po
						${DOMAIN}.pot
				DEPENDS
					${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.pot
					${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${LINGUA}.po
				WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po/${DOMAIN}
				COMMENT "pot-update [${DOMAIN}-${LINGUA}]: Updated po file."
			)

			SET(pot-update-SRC ${pot-update-SRC} ${DOMAIN}/${LINGUA}.po.dummy)

		endforeach(LINGUA ${LINGUAS})

		# Add to target list
		SET(pot-update-SRC
			${pot-update-SRC}
			${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${DOMAIN}.pot # should depend on languages
		)

	endforeach(DOMAIN ${NORMAL_DOMAINS})

	# Generate the stats based on completeness of all the .po files
	add_custom_command(
			# Same idea with a dummy file as in pot-update: we never make it, and run the command each time.
			OUTPUT ${PROJECT_SOURCE_DIR}/po/po_stat.dummy
			COMMAND python3 utils/po_stat.py
			--update-cfg
			--textdomains=wesnoth,wesnoth-editor,wesnoth-help,wesnoth-lib,wesnoth-multiplayer,wesnoth-tutorial,wesnoth-units,wesnoth-anl
			WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
			COMMENT "pot-update Updated data/languages/*.cfg files."
			# Needs to depend on the subset of .po files matching po_stat.py's --textdomains argument,
			# but for simplicity just depend on all the targets to update all .po files.
			DEPENDS ${pot-update-SRC}
	)

	SET(pot-update-SRC ${pot-update-SRC} ${PROJECT_SOURCE_DIR}/po/po_stat.dummy)

	# The target to call
	add_custom_target(pot-update
		COMMENT "pot-update: Done."
		DEPENDS ${pot-update-SRC}
	)


	##### po update per language #####
	# This is used to implement `make po-update-en_GB` etc. It started as a
	# copy of code from the main pot-update, no idea why commit
	# 93591845568158e00441094a2ede03e6bab8e285 changed only this copy.
	foreach(LINGUA ${LINGUAS})
		foreach(DOMAIN ${DOMAINS})
			add_custom_command(
				# The pot-update depends on a dummy file which we promise to
				# make. We don't make this dummy file but the pot-update
				# still works.
				OUTPUT ${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${LINGUA}.po.lang.dummy
				# After the po file is updated it might look not entirely as
				# wanted, for example poedit reorders the file. Use msgattrib
				# to reformat the file, use a helper file to do so.
				COMMAND ${GETTEXT_MSGATTRIB_EXECUTABLE}
						--output ${LINGUA}.po.tmp
						${LINGUA}.po
				COMMAND ${CMAKE_COMMAND} -E copy
						${LINGUA}.po.tmp
						${LINGUA}.po
				COMMAND ${CMAKE_COMMAND} -E remove
						${LINGUA}.po.tmp
				# Now merge with the pot file.
				COMMAND ${GETTEXT_MSGMERGE_EXECUTABLE}
						--backup=none
						--previous
						-U ${LINGUA}.po
						${DOMAIN}.pot
				WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po/${DOMAIN}
				COMMENT "po-update [${DOMAIN}-${LINGUA}]: Updated po file."
			)

			set(po-update-LINGUA-SRC ${po-update-LINGUA-SRC}
				${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${LINGUA}.po.lang.dummy
			)

		endforeach(DOMAIN ${DOMAINS})
# newer cmake minimum versions forbid the "@" symbol in certain targets
# this causes problems for translation targets such as "sr@latin"
		string(REPLACE "@" "_" target_name ${LINGUA})
		add_custom_target(po-update-${target_name} COMMENT "po-update ${LINGUA} as ${target_name}: Done." DEPENDS ${po-update-LINGUA-SRC})
		set(po-update-LINGUA-SRC "")
	endforeach(LINGUA ${LINGUAS})

endif(ENABLE_POT_UPDATE_TARGET)

if(ENABLE_NLS)

	set(GETTEXT_MSGFMT_PARAMETER --check-domain )

	if(ENABLE_POT_UPDATE_TARGET)
		# Only set the verbose flag for maintainers.
		set(GETTEXT_MSGFMT_PARAMETER -v ${GETTEXT_MSGFMT_PARAMETER} )
	endif(ENABLE_POT_UPDATE_TARGET)

	foreach(LINGUA ${LINGUAS})

		foreach(DOMAIN ${DOMAINS})

			file(MAKE_DIRECTORY ${CMAKE_SOURCE_DIR}/${LOCALEDIR}/${LINGUA}/LC_MESSAGES)

			add_custom_command(
				OUTPUT ${CMAKE_SOURCE_DIR}/${LOCALEDIR}/${LINGUA}/LC_MESSAGES/${DOMAIN}.mo
				COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
						${GETTEXT_MSGFMT_PARAMETER}
						-o ${CMAKE_SOURCE_DIR}/${LOCALEDIR}/${LINGUA}/LC_MESSAGES/${DOMAIN}.mo ${LINGUA}.po
				DEPENDS
					${PROJECT_SOURCE_DIR}/po/${DOMAIN}/${LINGUA}.po
				WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po/${DOMAIN}
				COMMENT "mo-update [${DOMAIN}-${LINGUA}]: Creating mo file."
			)

			list(FIND NORMAL_DOMAINS ${DOMAIN} IS_NORMAL_DOMAIN)
			if(IS_NORMAL_DOMAIN GREATER -1)
				install(FILES ${CMAKE_SOURCE_DIR}/${LOCALEDIR}/${LINGUA}/LC_MESSAGES/${DOMAIN}.mo
					DESTINATION ${LOCALE_INSTALL}/${LINGUA}/LC_MESSAGES)
			endif()

			set(mo-update-SRC ${mo-update-SRC}
				${CMAKE_SOURCE_DIR}/${LOCALEDIR}/${LINGUA}/LC_MESSAGES/${DOMAIN}.mo
			)
			set(mo-update-LINGUA-SRC ${mo-update-LINGUA-SRC}
				${CMAKE_SOURCE_DIR}/${LOCALEDIR}/${LINGUA}/LC_MESSAGES/${DOMAIN}.mo
			)

		endforeach(DOMAIN ${DOMAINS})

		if(ENABLE_POT_UPDATE_TARGET)
# newer cmake minimum versions forbid the "@" symbol in certain targets
# this causes problems for translation targets such as "sr@latin"
			string(REPLACE "@" "_" target_name ${LINGUA})
			add_custom_target(mo-update-${target_name} COMMENT "mo-update ${LINGUA} as ${target_name}: Done." DEPENDS ${mo-update-LINGUA-SRC})
			set(mo-update-LINGUA-SRC "")
		endif(ENABLE_POT_UPDATE_TARGET)

	endforeach(LINGUA ${LINGUAS})

	# The target to call
	add_custom_target(mo-update ALL
		COMMENT "mo-update: Done."
		DEPENDS ${mo-update-SRC}
	)

	set_directory_properties(properties
		ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_SOURCE_DIR}/${LOCALEDIR}
	)

endif(ENABLE_NLS)

=== src/CMakeLists.txt ===
# store the specified sources list in the specified variable
function(GetSources source_list store_in_var)
	file(STRINGS "../source_lists/${source_list}" sources)
	set(${store_in_var} ${sources} PARENT_SCOPE)
endfunction()

if(ENABLE_MYSQL)
	execute_process(COMMAND mysql_config --cflags OUTPUT_VARIABLE MYSQL_CFLAGS OUTPUT_STRIP_TRAILING_WHITESPACE)
	string(REGEX REPLACE "-I" "" MYSQL_CFLAGS "${MYSQL_CFLAGS}")
	string(REGEX REPLACE "-DNDEBUG" "" MYSQL_CFLAGS "${MYSQL_CFLAGS}")
	execute_process(COMMAND mysql_config --libs OUTPUT_VARIABLE MYSQL_LIBS OUTPUT_STRIP_TRAILING_WHITESPACE)
	add_subdirectory("modules/mariadbpp/")
endif()

## some includes ##
include_directories(SYSTEM ${PANGOCAIRO_INCLUDE_DIRS})
include_directories(SYSTEM ${GETTEXT_INCLUDE_DIR})
include_directories(SYSTEM ${LIBDBUS_INCLUDE_DIRS})
if(NOT MSVC)
	include_directories(SYSTEM ${SDL2IMAGE_INCLUDE_DIRS})
	include_directories(SYSTEM ${SDL2MIXER_INCLUDE_DIRS})
endif()

if(ZLIB_INCLUDE_DIR)
	include_directories(SYSTEM ${ZLIB_INCLUDE_DIR} )
endif()

# needed to get include paths in the subfolders correct
include_directories( ${CMAKE_SOURCE_DIR}/src/ )
# needed to have the generated config.h used, too
include_directories( ${CMAKE_CURRENT_BINARY_DIR} )

link_directories(
	${PANGOCAIRO_LIBRARY_DIRS}
	${LIBDBUS_LIBRARY_DIRS}
)

set(common-external-libs ${ICU_DATA_LIBRARY} ${ICU_I18N_LIBRARY} ${ICU_UC_LIBRARY})
if(MSVC)
	set(common-external-libs ${common-external-libs} shlwapi.lib winmm.lib crypt32.lib)
elseif(MINGW)
	set(common-external-libs ${common-external-libs} wsock32 ws2_32 shlwapi winmm crypt32)
elseif(APPLE)
	set(common-external-libs ${common-external-libs} ${APPKIT_LIBRARY} ${FOUNDATION_LIBRARY} ${IOKIT_LIBRARY} ${SECURITY_LIBRARY})
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
	set(common-external-libs ${common-external-libs} socket)
endif()

if(ENABLE_SYSTEM_LUA)
	add_compile_definitions(HAVE_SYSTEM_LUA=1)
	include_directories( SYSTEM ${LUA_INCLUDE_DIR} )
	set(common-external-libs ${common-external-libs} ${LUA_LIBRARIES})
endif()

set(game-external-libs
	${common-external-libs}
	${PANGOCAIRO_LIBRARIES}
	${LIBDBUS_LIBRARIES}
	VorbisFile::VorbisFile
)

if(NOT MSVC)
	set(game-external-libs
		${game-external-libs}
		${SDL2IMAGE_LIBRARIES}
		${SDL2MIXER_LIBRARIES}
	)
endif()

if(HISTORY_FOUND)
	set(game-external-libs ${game-external-libs} History::History)
endif()

# get source lists
GetSources("libwesnoth_sdl" wesnoth_sdl_sources)
GetSources("libwesnoth_widgets" wesnoth_widget-sources)
GetSources("libwesnoth" wesnoth_game_sources)
GetSources("libwesnoth_core" wesnoth_core_sources)
GetSources("wesnoth" wesnoth_sources)
if(NOT ENABLE_SYSTEM_LUA)
	GetSources("lua" lua_sources)

	# Inject a header into the Lua sources for Wesnoth-specific changes
	# makedepend won't see it so we have to specifically add it as a dependency.
	file(GLOB wesnoth_lua_config wesnoth_lua_config.h)
	set_source_files_properties(${lua_sources} PROPERTIES OBJECT_DEPENDS ${wesnoth_lua_config})

	set_source_files_properties(${lua_sources} PROPERTIES LANGUAGE CXX)

	# We explicitly want lua compiled as C++ version
	if(MSVC)
		set_source_files_properties(${lua_sources} PROPERTIES COMPILE_FLAGS "/FI\"${wesnoth_lua_config}\"")
		# silence an implicit bitshift conversion warning
		set_property(SOURCE SOURCE ${lua_sources} APPEND_STRING PROPERTY COMPILE_FLAGS " /wd4334 /TP")
	else()
		set_source_files_properties(${lua_sources} PROPERTIES COMPILE_FLAGS "-include \"${wesnoth_lua_config}\" -x c++ -Wno-old-style-cast -Wno-useless-cast -Wno-stringop-overflow")
	endif()

	if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
		# silence a Clang specific warning due to extra parenthesis in if statements
		set_property(SOURCE SOURCE ${lua_sources} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-parentheses-equality")
		# silence a Clang specific warning when compiling the lua code
		set_property(SOURCE SOURCE ${lua_sources} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-string-plus-int")
	endif()
endif()

if(WIN32)
	set(wesnoth_core_sources ${wesnoth_core_sources} log_windows.cpp)
	set(wesnoth_game_sources ${wesnoth_game_sources} desktop/windows_tray_notification.cpp desktop/windows_battery_info.cpp)
endif()

# On apple only
if(APPLE)
	set(wesnoth_game_sources
		${wesnoth_game_sources}
		desktop/apple_battery_info.mm
		desktop/apple_notification.mm
		desktop/apple_version.mm
		desktop/apple_video.mm
	)
endif()

# For libdbus (essentially just for linux), this file needs to be linked, as its header is included #ifdef HAVE_LIBDBUS
if(LIBDBUS_FOUND)
	set(wesnoth_game_sources ${wesnoth_game_sources} desktop/dbus_features.cpp)
endif()

# Depending on the flag create a real file or an empty dummy.
#
# Since the code is executed every build run of Wesnoth we need to make sure
# that no modifications don't turn into a rebuild. Therefore a the dummy is
# created and the second target only copies the file if modified.
if(ENABLE_DISPLAY_REVISION)
	add_custom_target(wesnoth-revision_dummy
		COMMAND ${CMAKE_SOURCE_DIR}/utils/autorevision.sh -t h > ${CMAKE_CURRENT_BINARY_DIR}/revision.dummy
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
	)

	add_custom_target(wesnoth-revision
		COMMAND ${CMAKE_COMMAND} -E copy_if_different
			${CMAKE_CURRENT_BINARY_DIR}/revision.dummy
			${CMAKE_CURRENT_BINARY_DIR}/revision.h
	)

	add_dependencies(wesnoth-revision wesnoth-revision_dummy)
	set_source_files_properties(game_config.cpp PROPERTIES COMPILE_DEFINITIONS "LOAD_REVISION")
endif()

########### Conf Tests ###########

if((ENABLE_GAME OR ENABLE_TESTS) AND NOT MSVC)
	# test for SDL2
	add_executable(sdl2 conftests/sdl2.cpp)
	set_target_properties(sdl2 PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/Testing)
	target_link_libraries(sdl2 ${game-external-libs})
	# cmake checks the version elsewhere already, but scons uses this, which is why the three arguments for major.minor.patchlevel are 0 here
	add_test(NAME SDL2_SUPPORT COMMAND sdl2 0 0 0)

	# test for SDL2_image
	add_executable(sdl2_image conftests/sdl2_image.cpp)
	set_target_properties(sdl2_image PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/Testing)
	target_link_libraries(sdl2_image ${game-external-libs})
	add_test(NAME SDL2_IMAGE_SUPPORT COMMAND sdl2_image)

	# test for SDL2_mixer
	add_executable(sdl2_mixer conftests/sdl2_mixer.cpp)
	set_target_properties(sdl2_mixer PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/Testing)
	target_link_libraries(sdl2_mixer ${game-external-libs})
	add_test(NAME SDL2_MIXER_SUPPORT COMMAND sdl2_mixer)

	# test for JPG support in SDL2
	add_executable(sdl2_jpg conftests/sdl2_jpg.cpp)
	set_target_properties(sdl2_jpg PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/Testing)
	target_link_libraries(sdl2_jpg ${game-external-libs})
	add_test(NAME SDL2_JPG_SUPPORT COMMAND sdl2_jpg "${CMAKE_SOURCE_DIR}/data/core/images/scons_conftest_images/end-n.jpg")

	# test for PNG support in SDL2
	add_executable(sdl2_png conftests/sdl2_png.cpp)
	set_target_properties(sdl2_png PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/Testing)
	target_link_libraries(sdl2_png ${game-external-libs})
	add_test(NAME SDL2_PNG_SUPPORT COMMAND sdl2_png "${CMAKE_SOURCE_DIR}/data/core/images/scons_conftest_images/end-n.png")

	# test for WEBP support in SDL2
	add_executable(sdl2_webp conftests/sdl2_webp.cpp)
	set_target_properties(sdl2_webp PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/Testing)
	target_link_libraries(sdl2_webp ${game-external-libs})
	add_test(NAME SDL2_WEBP_SUPPORT COMMAND sdl2_webp "${CMAKE_SOURCE_DIR}/data/core/images/scons_conftest_images/end-n.webp")

	# test for audio support in SDL2
	add_executable(sdl2_audio conftests/sdl2_audio.cpp)
	set_target_properties(sdl2_audio PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/Testing)
	target_link_libraries(sdl2_audio ${game-external-libs})
	add_test(NAME SDL2_AUDIO_SUPPORT COMMAND sdl2_audio "${CMAKE_SOURCE_DIR}/data/core/music/main_menu.ogg")

	add_custom_target(conftests
		COMMAND ${CMAKE_COMMAND} -E env "SDL_AUDIODRIVER=dummy" ${CMAKE_CTEST_COMMAND}
		DEPENDS
			sdl2
			sdl2_image
			sdl2_mixer
			sdl2_jpg
			sdl2_png
			sdl2_webp
			sdl2_audio
	)
endif()

########### Wesnoth ###############

add_library(wesnoth-common STATIC ${wesnoth_core_sources})
if(ENABLE_GAME OR ENABLE_TESTS)
	add_library(wesnoth-client STATIC ${wesnoth_sources} ${lua_sources} ${wesnoth_game_sources} ${wesnoth_sdl_sources})

	# widgets need special handling since otherwise the way they're registered causes the linker to remove them since it incorrectly thinks they're unused
	add_library(wesnoth-widgets STATIC ${wesnoth_widget-sources})
	if(APPLE)
		set(WIDGETS_LIB -Wl,-force_load wesnoth-widgets)
	elseif(NOT MSVC)
		set(WIDGETS_LIB -Wl,--whole-archive wesnoth-widgets -Wl,--no-whole-archive)
	else()
		# handled by /WHOLEARCHIVE below
		set(WIDGETS_LIB wesnoth-widgets)
	endif()
endif()

if(ENABLE_GAME)
	if(WIN32)
		add_executable(wesnoth WIN32 wesnoth.cpp ../packaging/windows/wesnoth.rc)
		if(MSVC)
			target_link_options(wesnoth PRIVATE /WX /WHOLEARCHIVE:wesnoth-widgets)
		endif()
	elseif(APPLE)
		add_executable(wesnoth wesnoth.cpp macosx/SDLMain.mm)
	else()
		add_executable(wesnoth wesnoth.cpp)
	endif()

	target_link_libraries(wesnoth
		wesnoth-common
		${WIDGETS_LIB}
		wesnoth-client
		wesnoth-common
		${game-external-libs}
		OpenSSL::Crypto
		OpenSSL::SSL
		Boost::iostreams
		Boost::program_options
		Boost::regex
		Boost::system
		Boost::random
		Boost::coroutine
		Boost::locale
		Boost::filesystem
		Fontconfig::Fontconfig
		SDL2::SDL2
		SDL2::SDL2main
		CURL::libcurl
	)
	if(MSVC)
		target_link_libraries(wesnoth SDL2_image::SDL2_image)
		target_link_libraries(wesnoth SDL2_mixer::SDL2_mixer)
	endif()

	if(ENABLE_DISPLAY_REVISION)
		add_dependencies(wesnoth wesnoth-revision)
	endif()

	set_target_properties(wesnoth PROPERTIES OUTPUT_NAME ${BINARY_PREFIX}wesnoth${BINARY_SUFFIX})

	install(TARGETS wesnoth DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

########### Boost Unit tests ###############

if(ENABLE_TESTS)
	add_definitions(-DBOOST_TEST_DYN_LINK)

	GetSources("boost_unit_tests" boost_tests_sources)
	add_executable(boost_unit_tests ${boost_tests_sources})

	if(MSVC)
		target_link_options(boost_unit_tests PRIVATE /WX /WHOLEARCHIVE:wesnoth-widgets)
	endif()

	target_link_libraries(boost_unit_tests
		wesnoth-common
		${WIDGETS_LIB}
		wesnoth-client
		wesnoth-common
		${game-external-libs}
		OpenSSL::Crypto
		OpenSSL::SSL
		Boost::iostreams
		Boost::program_options
		Boost::regex
		Boost::system
		Boost::random
		Boost::coroutine
		Boost::locale
		Boost::filesystem
		Boost::unit_test_framework
		Fontconfig::Fontconfig
		SDL2::SDL2
		SDL2::SDL2main
		CURL::libcurl
	)
	if(MSVC)
		target_link_libraries(boost_unit_tests SDL2_image::SDL2_image)
		target_link_libraries(boost_unit_tests SDL2_mixer::SDL2_mixer)
	endif()

	if(ENABLE_DISPLAY_REVISION)
		add_dependencies(boost_unit_tests wesnoth-revision)
	endif()

	set_target_properties(boost_unit_tests PROPERTIES OUTPUT_NAME ${BINARY_PREFIX}boost_unit_tests${BINARY_SUFFIX})
endif()

########### Wesnothd Server ###############

if(ENABLE_SERVER)
	GetSources("wesnothd" wesnothd_sources)

	if(WIN32)
		add_executable(wesnothd ${wesnothd_sources} ../packaging/windows/wesnothd.rc)
	else()
		add_executable(wesnothd ${wesnothd_sources})
	endif()

	if(ENABLE_MYSQL)
		target_include_directories(wesnothd SYSTEM PRIVATE ${MYSQL_CFLAGS})
		target_compile_definitions(wesnothd PRIVATE HAVE_MYSQLPP)
		target_link_libraries(wesnothd mariadbclientpp)
	endif()

	target_link_libraries(wesnothd
		wesnoth-common
		${common-external-libs}
		${MYSQL_LIBS}
		OpenSSL::Crypto
		OpenSSL::SSL
		Boost::iostreams
		Boost::program_options
		Boost::regex
		Boost::system
		Boost::random
		Boost::coroutine
		Boost::locale
		Boost::filesystem
	)
	if(MSVC)
		target_link_options(wesnothd PRIVATE /WX)
	endif()

	set_target_properties(wesnothd PROPERTIES OUTPUT_NAME ${BINARY_PREFIX}wesnothd${BINARY_SUFFIX})
	if(ENABLE_DISPLAY_REVISION)

=== doc/manual/CMakeLists.txt ===
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM true)

install(FILES manual.en.html DESTINATION "${CMAKE_INSTALL_DOCDIR}/html")
install(DIRECTORY images styles
	DESTINATION "${CMAKE_INSTALL_DOCDIR}/html"
	PATTERN ".git" EXCLUDE
)

if(ENABLE_NLS)
	foreach(LANG ${LINGUAS})
		install(FILES manual.${LANG}.html DESTINATION "${CMAKE_INSTALL_DOCDIR}/html" OPTIONAL)
	endforeach(LANG ${LINGUAS})
endif(ENABLE_NLS)


if(ENABLE_POT_UPDATE_TARGET)

	add_custom_command(
		OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/manual.en.xml
		COMMAND ${CMAKE_COMMAND} -E remove manual.en.xml
		COMMAND ${CMAKE_COMMAND} -E remove manual.en.html
		COMMAND ${ASCIIDOC_EXECUTABLE} ${ASCIIDOC_OPTIONS}
				-o manual.en.xml
				manual.txt
		COMMAND ${DOS2UNIX_EXECUTABLE} manual.en.xml
		COMMAND ${XSLTPROC_EXECUTABLE} ${XSLTPROC_OPTIONS}
				-o manual.en.html
				${ASCIIDOC_DOCBOOK_XSL_PATH}/xhtml.xsl
				manual.en.xml
		DEPENDS manual.txt
		COMMENT "[update-po4a-manual] Building manual.xml."
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)

	add_custom_command(
		OUTPUT ${PROJECT_SOURCE_DIR}/po/wesnoth-manual/wesnoth-manual.pot
		COMMAND ${PO4A-UPDATEPO_EXECUTABLE} ${PO4A-UPDATEPO_OPTIONS}
				--copyright-holder "Wesnoth Development Team"
				-f docbook
				-m ${CMAKE_CURRENT_SOURCE_DIR}/manual.en.xml
				-p wesnoth-manual.pot
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/manual.en.xml
		COMMENT "[update-po4a-manual] Building wesnoth-manual.pot."
		WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po/wesnoth-manual
	)

	set(UPDATE-PO4A-MANUAL_DEPENDENCIES)
	foreach(LINGUA ${LINGUAS})

		add_custom_command(
			OUTPUT ${PROJECT_SOURCE_DIR}/po/wesnoth-manual/${LINGUA}.po
			COMMAND ${PO4A-UPDATEPO_EXECUTABLE} ${PO4A-UPDATEPO_OPTIONS}
					-f docbook
					-m ${CMAKE_CURRENT_SOURCE_DIR}/manual.en.xml
					-p ${LINGUA}.po
			DEPENDS ${PROJECT_SOURCE_DIR}/po/wesnoth-manual/wesnoth-manual.pot
			COMMENT "[update-po4a-manual ${LINGUA}] Building ${LINGUA}.po."
			WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po/wesnoth-manual
		)

		# Create the .xml file if enough strings are translated.
		add_custom_command(
			OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/manual.${LINGUA}.xml
			COMMAND ${PO4A-TRANSLATE_EXECUTABLE} ${PO4A-TRANSLATE_OPTIONS}
					-m ${CMAKE_CURRENT_SOURCE_DIR}/manual.en.xml
					-p ${LINGUA}.po
					-l ${CMAKE_CURRENT_SOURCE_DIR}/manual.${LINGUA}.xml
			DEPENDS ${PROJECT_SOURCE_DIR}/po/wesnoth-manual/${LINGUA}.po
			COMMENT "[update-po4a-manual ${LINGUA}] Building ${LINGUA}.xml."
			WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po/wesnoth-manual
		)


		# Only create a .html if there is an .xml file. Since it's not
		# possible to only execute cmake code if the file exists directly,
		# build the command here. Then send it to a small script that only
		# executes if the .html file exists.
		set(CMD "${XSLTPROC_EXECUTABLE} ${XSLTPROC_OPTIONS}")
		set(CMD "${CMD} -o manual.${LINGUA}.html")
		set(CMD "${CMD} ${ASCIIDOC_DOCBOOK_XSL_PATH}/xhtml.xsl")
		set(CMD "${CMD} manual.${LINGUA}.xml")
		add_custom_command(
			OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/manual.${LINGUA}.html
			COMMAND ${CMAKE_COMMAND} -E remove manual.${LINGUA}.html
			COMMAND ${CMAKE_COMMAND}
				-DSOURCE="manual.${LINGUA}.xml"
				-DCMD="${CMD}"
				-P "${CMAKE_SOURCE_DIR}/cmake/po4a-manual.cmake"
			COMMAND ${CMAKE_COMMAND} -E remove manual.${LINGUA}.xml
			DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/manual.${LINGUA}.xml
			COMMENT "[update-po4a-manual ${LINGUA}] Building ${LINGUA}.html."
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		)

		set(UPDATE-PO4A-MANUAL_DEPENDENCIES
			${UPDATE-PO4A-MANUAL_DEPENDENCIES}
			${CMAKE_CURRENT_SOURCE_DIR}/manual.${LINGUA}.html
		)
	endforeach(LINGUA ${LINGUAS})

	add_custom_target(update-po4a-manual
		COMMAND ${CMAKE_COMMAND} -E remove manual.en.xml
		DEPENDS
			${UPDATE-PO4A-MANUAL_DEPENDENCIES}
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)

endif(ENABLE_POT_UPDATE_TARGET)

=== src/ai/SConstruct ===
import sys
from subprocess import call
print("scons --directory=../.. " + " ".join(sys.argv[1:]))
Exit(call(Split("scons --directory=../..") + sys.argv[1:]))

=== src/modules/mariadbpp/CMakeLists.txt ===
#          Copyright The ViaDuck Project 2016 - 2021.
# Distributed under the Boost Software License, Version 1.0.
#    (See accompanying file LICENSE or copy at
#          http://www.boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 3.8)
project(mariadbclientpp LANGUAGES CXX)

include(GNUInstallDirs)
option(MARIADBPP_TEST "Build mariadbpp tests" OFF)
option(MARIADBPP_DOC "Build mariadbpp docs" OFF)
option(MARIADBPP_QUIET "Turn off error logging" OFF)

# add additional cmake modules
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/external/cmake-modules")

# dependencies
find_package(MariaDBClient REQUIRED)
find_package(Threads REQUIRED)

# find files
file(GLOB mariadbclientpp_PUBLIC_HEADERS include/mariadb++/*)
file(GLOB mariadbclientpp_PRIVATE_HEADERS src/*.hpp)
file(GLOB mariadbclientpp_SOURCES src/*.cpp)

# set up target
add_library(mariadbclientpp ${mariadbclientpp_SOURCES} ${mariadbclientpp_PUBLIC_HEADERS} ${mariadbclientpp_PRIVATE_HEADERS})

# target options
target_link_libraries(mariadbclientpp MariaDBClient::MariaDBClient Threads::Threads)

target_include_directories(
	mariadbclientpp
	PUBLIC
	"$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
	"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")

target_compile_features(mariadbclientpp PUBLIC cxx_std_11)
target_compile_definitions(mariadbclientpp PUBLIC MARIADB_QUIET=$<BOOL:${MARIADBPP_QUIET}>)

if (MSVC)
    target_compile_options(mariadbclientpp PRIVATE /W4)
else()
    target_compile_options(mariadbclientpp PRIVATE -Wall -Wextra)
endif()

# install configuration
install(FILES ${mariadbclientpp_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/mariadb++)
install(TARGETS mariadbclientpp
	EXPORT mariadbclientpp_export
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

configure_file("cmake/mariadbclientpp-config.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/mariadbclientpp-config.cmake" @ONLY)

install(
	EXPORT mariadbclientpp_export
	DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/mariadbclientpp"
	NAMESPACE "mariadbclientpp::"
	# In this CMake config file no dependencies are considered. But since we
	# do not use any `find_package` call here this approach is sufficient.
	FILE mariadbclientpp-targets.cmake
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/mariadbclientpp-config.cmake"
	"${PROJECT_SOURCE_DIR}/external/cmake-modules/FindMariaDBClient.cmake"
	DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/mariadbclientpp")

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "MariaDB++")
SET(CPACK_PACKAGE_VENDOR "ViaDuck")
SET(CPACK_PACKAGE_VERSION "1.0.0")
SET(CPACK_GENERATOR "RPM;DEB")
SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Nobody")
INCLUDE(CPack)

# tests
if (MARIADBPP_TEST)
	add_subdirectory(test)
endif()

if (MARIADBPP_DOC)
	# doxygen
	include(Doxygen)
	if (DOXYGEN_FOUND)
		setup_doxygen(mariadbpp_doc ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
	endif()
endif()

=== debian/changelog ===
wesnoth-1.18 (1:1.18.5-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Vincent Cheng <vcheng@debian.org>  Sat, 24 May 2025 02:12:14 -0700

wesnoth-1.18 (1:1.18.5-1) unstable; urgency=medium

  * New upstream stable release (minor bugfixes and translation updates).
    - Fixes FTBFS with gcc 15. (Closes: #1098091)
  * Bump Standards-Version to 4.7.2, no changes needed.

 -- Vincent Cheng <vcheng@debian.org>  Fri, 23 May 2025 16:00:48 -0700

wesnoth-1.18 (1:1.18.4-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Vincent Cheng <vcheng@debian.org>  Fri, 21 Feb 2025 01:10:36 -0800

wesnoth-1.18 (1:1.18.3-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Vincent Cheng <vcheng@debian.org>  Fri, 22 Nov 2024 03:07:09 -0800

=== debian/control ===
Source: wesnoth-1.18
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Build-Depends:
 cmake (>= 3.14),
 debhelper-compat (= 13),
 libboost-coroutine-dev       (>= 1.66.0),
 libboost-filesystem-dev      (>= 1.66.0),
 libboost-graph-dev           (>= 1.66.0),
 libboost-iostreams-dev       (>= 1.66.0),
 libboost-locale-dev          (>= 1.66.0),
 libboost-program-options-dev (>= 1.66.0),
 libboost-random-dev          (>= 1.66.0),
 libboost-regex-dev           (>= 1.66.0),
 libboost-system-dev          (>= 1.66.0),
 libboost-test-dev            (>= 1.66.0),
 libboost-thread-dev          (>= 1.66.0),
 libcairo2-dev (>= 1.10.0),
 libcurl4-openssl-dev,
 libdbus-1-dev,
 libfontconfig-dev (>= 2.4.1),
 libpango1.0-dev (>= 1.44.0),
 libreadline-dev,
 libsdl2-dev (>= 2.0.18),
 libsdl2-image-dev (>= 2.0.2),
 libsdl2-mixer-dev (>= 2.0.0),
 libssl-dev (>= 1.0),
 libvorbis-dev,
 pkgconf,
 python3,
Standards-Version: 4.7.2
Uploaders:
 Rhonda D'Vine <rhonda@debian.org>,
 Vincent Cheng <vcheng@debian.org>,
 P. J. McDermott <pj@pehjota.net>,
Homepage: https://www.wesnoth.org/
Vcs-Git: https://salsa.debian.org/games-team/wesnoth.git
Vcs-Browser: https://salsa.debian.org/games-team/wesnoth
Rules-Requires-Root: no

Package: wesnoth-1.18-data
Architecture: all
Multi-Arch: foreign
Depends:
 fonts-adf-oldania,
 fonts-dejavu-core,
 fonts-dejavu-extra,
 fonts-droid-fallback,
 fonts-lato,
 fonts-lohit-beng-bengali,
 ${misc:Depends},
Suggests:
 wesnoth-1.18-music,
Description: data files for Wesnoth (branch 1.18)
 This package contains the sound files and graphics for Wesnoth. It is required
 for being able to play wesnoth or create maps with the editor.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

# TODO: Remove package after Debian trixie
Package: wesnoth-core
Architecture: all
Section: oldlibs
Depends:
 wesnoth-1.18 (>= ${binary:Version}),
 wesnoth-1.18-data (= ${source:Version}),
 ${misc:Depends},
Description: fantasy turn-based strategy game (transitional package)
 This is a transitional dummy metapackage.  It can safely be removed.
 To play the latest stable version of Wesnoth, install the wesnoth package.
 To play multiplayer games or user-made add-ons without installing all the
 official campaigns and music, install the wesnoth package without recommended
 packages.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18
Architecture: any
Depends:
 wesnoth-1.18-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 wesnoth-1.18-did (= ${source:Version}),
 wesnoth-1.18-dm (= ${source:Version}),
 wesnoth-1.18-dw (= ${source:Version}),
 wesnoth-1.18-ei (= ${source:Version}),
 wesnoth-1.18-httt (= ${source:Version}),
 wesnoth-1.18-l (= ${source:Version}),
 wesnoth-1.18-low (= ${source:Version}),
 wesnoth-1.18-music (= ${source:Version}),
 wesnoth-1.18-nr (= ${source:Version}),
 wesnoth-1.18-sof (= ${source:Version}),
 wesnoth-1.18-sota (= ${source:Version}),
 wesnoth-1.18-sotbe (= ${source:Version}),
 wesnoth-1.18-thot (= ${source:Version}),
 wesnoth-1.18-trow (= ${source:Version}),
 wesnoth-1.18-tsg (= ${source:Version}),
 wesnoth-1.18-ttb (= ${source:Version}),
 wesnoth-1.18-utbs (= ${source:Version}),
 wesnoth-1.18-wof (= ${source:Version}),
Breaks:
 wesnoth-1.18-core (<< 1:1.16.11-1.~),
Replaces:
 wesnoth-1.18-core (<< 1:1.16.11-1.~),
Description: fantasy turn-based strategy game (branch 1.18)
 This package contains the main program for Wesnoth.  If you only want to
 play a few official campaigns, multiplayer games over the network with other
 players, user-made add-ons, and/or without music, install this package without
 recommended packages.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth
Architecture: all
Depends:
 wesnoth-1.18 (>= ${binary:Version}),
 wesnoth-1.18-data (= ${source:Version}),
 ${misc:Depends},
Description: fantasy turn-based strategy game (metapackage)
 This metapackage pulls in the main Wesnoth package which allows you to play
 using the latest stable version.  If you only want to play a few official
 campaigns, multiplayer games over the network with other players, user-made
 add-ons, and/or without music, install this package without recommended
 packages.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-music
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: music files for Wesnoth (branch 1.18)
 This package contains the music files for Wesnoth. It is not required but
 gives nice background music and encouraged.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-music
Architecture: all
Multi-Arch: foreign
Depends:
 wesnoth-1.18-data (= ${source:Version}),
 wesnoth-1.18-music (= ${source:Version}),
 ${misc:Depends},
Description: music files for Wesnoth (metapackage)
 This metapackage pulls in the music package for use with the latest stable
 version of wesnoth.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-server
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Description: multiplayer network server for Wesnoth (branch 1.18)
 This package contains the multiplayer network server for Wesnoth.  You need it
 if you want to host multiplayer games on your computer and don't want to use
 the official servers.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-tools
Architecture: all
Multi-Arch: foreign
Depends:
 python3:any,
 wesnoth-1.18-data (= ${source:Version}),
 ${misc:Depends},
 ${perl:Depends},
Recommends:
 imagemagick | graphicsmagick-imagemagick-compat,
Enhances:
 wesnoth-1.18 (>> 1:1.16.11-1.~),
 wesnoth-1.18-core (<< 1:1.16.11-1.~),
Description: tools for campaign developers for Wesnoth (branch 1.18)
 This package contains various tools for Wesnoth that are especially useful for
 campaign developers, including but not limited to scripts supporting the
 generation and checking of WML (Wesnoth Markup Language).  You can find them
 in the directory /usr/share/games/wesnoth/1.18/data/tools
 after installation of the package.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-httt
Depends:
 wesnoth-1.18 (<< ${wesnoth:Max-Version}),
 wesnoth-1.18 (>= ${wesnoth:Min-Version}),
 ${misc:Depends},
Architecture: all
Description: "Heir to the Throne" official campaign for Wesnoth (branch 1.18)
 This package contains the "Heir to the Throne" campaign for Wesnoth:
 "Fight to regain the throne of Wesnoth, of which you are the legitimate
 heir."
 (Novice level, 23 scenarios.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-tsg
Depends:
 wesnoth-1.18 (<< ${wesnoth:Max-Version}),
 wesnoth-1.18 (>= ${wesnoth:Min-Version}),
 ${misc:Depends},
Architecture: all
Description: "The South Guard" official campaign for Wesnoth (branch 1.18)
 This package contains the "The South Guard" campaign for Wesnoth:
 "A young Knight, Deoran, is dispatched to take command of the South Guard...
 Note: This campaign is designed as an introduction to Wesnoth. The 'Civilian'
 difficulty level is aimed at first-time players."
 (Novice level, 9 scenarios.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-trow
Depends:
 wesnoth-1.18 (<< ${wesnoth:Max-Version}),
 wesnoth-1.18 (>= ${wesnoth:Min-Version}),
 ${misc:Depends},
Architecture: all
Description: "The Rise of Wesnoth" official campaign for Wesnoth (branch 1.18)
 This package contains the "The Rise of Wesnoth" campaign for Wesnoth:
 "Lead Prince Haldric through the destruction of the Green Isle and across the
 Ocean to establish the very kingdom of Wesnoth itself. The confrontation with
 Lich-Lord Jevyan awaits..."
 (Intermediate level, 24 scenarios.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-ttb
Depends:
 wesnoth-1.18 (<< ${wesnoth:Max-Version}),
 wesnoth-1.18 (>= ${wesnoth:Min-Version}),
 ${misc:Depends},
Architecture: all
Description: "A Tale of Two Brothers" official campaign for Wesnoth (branch 1.18)
 This package contains the "A Tale of Two Brothers" campaign for Wesnoth:
 "An evil mage is threatening the small village of Maghre and its inhabitants.
 The village’s mage sends to his warrior brother for help, but not all goes as
 planned. Can you help?"
 (Novice level, 4 scenarios.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-ei
Depends:
 wesnoth-1.18 (<< ${wesnoth:Max-Version}),
 wesnoth-1.18 (>= ${wesnoth:Min-Version}),
 ${misc:Depends},
Architecture: all
Description: "The Eastern Invasion" official campaign for Wesnoth (branch 1.18)
 This package contains the "The Eastern Invasion" campaign for Wesnoth:
 "There are rumors of undead attacks on the eastern border of Wesnoth. You, an
 officer in the Royal Army, have been sent to the eastern front to protect the
 villagers and find out what is happening."
 (Intermediate level, 16 scenarios.)"
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for wesnoth
# copyright 2007-2018 by Rhonda D'Vine <rhonda@debian.org>
# Licenced under MIT

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# for DEB_VERSION* variables
include /usr/share/dpkg/pkg-info.mk

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_ARCH  ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# less debug info to avoid running out of address space
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
    CXXFLAGSDBG = -g1
endif

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS   := $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) -std=c11
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS) -std=c++11 $(CXXFLAGSDBG)
export LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

ifneq (,$(filter $(DEB_BUILD_ARCH),alpha))
  LDFLAGS += -Wl,--no-relax
endif
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
        CFLAGS += -O0
else
        CFLAGS += -O2
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif


# used for package name extension
BRANCH_VERSION = $(shell echo $(DEB_SOURCE) | sed 's/^wesnoth-//')
BRANCH_MAJOR   = $(shell echo $(BRANCH_VERSION) | cut -d. -f1)
BRANCH_MINOR   = $(shell echo $(BRANCH_VERSION) | cut -d. -f2)
BRANCH_ISDEV   = $(shell echo $$(( $(BRANCH_MINOR) % 2 )) )

# calculate the version strings
EPOCH_VERSION = $(shell echo $(DEB_VERSION) | cut -d: -f1)
MAJOR_VERSION = $(shell echo $(DEB_VERSION) | cut -d. -f1)
MINOR_VERSION = $(shell echo $(DEB_VERSION) | cut -d. -f2 | cut -d- -f1 | sed -e 's/[^0-9]//g')
ISDEV_VERSION = $(shell echo $$(( $(MINOR_VERSION) % 2 )) )
UPSTR_VERSION = $(DEB_VERSION_EPOCH_UPSTREAM)

# choose correct MIN_VERSION (for >=) and MAX_VERSION (for <<) depending on
# ISDEV_VERSION and BRANCH_ISDEV
ifeq ($(ISDEV_VERSION), 1)
ifeq ($(BRANCH_ISDEV), 1)
	# e.g. wesnoth-1.17 (1:1.17.0-1)
	# Depends: wesnoth-1.17 (<< 1:1.17.0.~), wesnoth-1.17 (>= 1:1.17.0)
	MIN_VERSION = $(UPSTR_VERSION)
	MAX_VERSION = $(UPSTR_VERSION).~
else
	# e.g. wesnoth-1.18 (1:1.17.26-1)
	# Depends: wesnoth-1.18 (<< 1:1.19), wesnoth-1.18 (>= 1:1.17.26)
	MIN_VERSION = $(UPSTR_VERSION)
	MAX_VERSION = $(MAJOR_VERSION).$(shell echo $$(( $(MINOR_VERSION) + 2 )) )
endif
else
	# e.g. wesnoth-1.18 (1:18.0-1)
	# Depends: wesnoth-1.18 (<< 1:1.19), wesnoth-1.18 (>= 1:1.18)
	MIN_VERSION = $(MAJOR_VERSION).$(MINOR_VERSION)
	MAX_VERSION = $(MAJOR_VERSION).$(shell echo $$(( $(MINOR_VERSION) + 1 )) )
endif

CMAKE_SWITCHES = \
	-DBINARY_SUFFIX="-$(BRANCH_VERSION)" \
	-DCMAKE_INSTALL_PREFIX="/usr/" \
	-DCMAKE_INSTALL_BINDIR="/usr/games" \
	-DCMAKE_INSTALL_DATAROOTDIR="/usr/share/games" \
	-DDATADIRNAME="wesnoth/$(BRANCH_VERSION)" \
	-DCMAKE_INSTALL_DOCDIR="/usr/share/doc/wesnoth-$(BRANCH_VERSION)-data" \
	-DLOCALEDIR="locale" \
	-DCMAKE_INSTALL_MANDIR="/usr/share/man" \
	-DPREFERENCES_DIR=".config/wesnoth-$(BRANCH_VERSION)" \
	-DFIFO_DIR=/run/wesnothd/$(BRANCH_VERSION) \
	-DCMAKE_VERBOSE_MAKEFILE=on

SYSTEMD_SERVICE = debian/wesnoth-$(BRANCH_VERSION)-server/lib/systemd/system/wesnoth-$(BRANCH_VERSION)-server.service

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_SWITCHES)

override_dh_auto_test:
	# sets "SDL_AUDIODRIVER=dummy" so the SDL_Mixer test works under sbuild,
	# unlike the regular "tests" target.
	dh_auto_build -- conftests

override_dh_install:
	# helpheader.html is not referenced by anything installed in the binary
	# packages and it causes lintian to complain about embedded jquery and
	# privacy-breach-generic warnings, so avoid installing it.
	dh_install -Xgitignore -Xhelpheader.html -Xhelptrailer.html

execute_after_dh_install-arch:
	# manpage symlinks for old binaries
	for i in debian/wesnoth-$(BRANCH_VERSION)/usr/share/man/*/man6/wesnoth.6; do \
		ln -s wesnoth-$(BRANCH_VERSION).6.gz \
			`dirname $$i`/wesnoth-$(BRANCH_VERSION)-smallgui.6.gz; \
		ln -s wesnoth-$(BRANCH_VERSION).6.gz \
			`dirname $$i`/wesnoth-$(BRANCH_VERSION)_editor.6.gz; \
	done
	ln -s wesnoth-$(BRANCH_VERSION).6.gz \
		debian/wesnoth-$(BRANCH_VERSION)/usr/share/man/man6/wesnoth-$(BRANCH_VERSION)-smallgui.6.gz
	ln -s wesnoth-$(BRANCH_VERSION).6.gz \
		debian/wesnoth-$(BRANCH_VERSION)/usr/share/man/man6/wesnoth-$(BRANCH_VERSION)_editor.6.gz
	
	# move the manpages to their proper name
	for i in debian/wesnoth-$(BRANCH_VERSION)/usr/share/man/man6/wesnoth.6 \
		debian/wesnoth-$(BRANCH_VERSION)/usr/share/man/*/man6/wesnoth.6; do \
		mv $$i $$(echo $$i | sed -e 's/wesnoth\.6/wesnoth-$(BRANCH_VERSION).6/'); \
	done
	for i in debian/wesnoth-$(BRANCH_VERSION)-server/usr/share/man/man6/wesnothd.6 \
		debian/wesnoth-$(BRANCH_VERSION)-server/usr/share/man/*/man6/wesnothd.6; do \
		mv $$i $$(echo $$i | sed -e 's/wesnothd\.6/wesnothd-$(BRANCH_VERSION).6/'); \
	done
	
	# move the desktop and metainfo files to their proper name
	mv debian/wesnoth-$(BRANCH_VERSION)/usr/share/applications/org.wesnoth.Wesnoth.desktop \
		debian/wesnoth-$(BRANCH_VERSION)/usr/share/applications/org.wesnoth.Wesnoth-$(BRANCH_VERSION).desktop
	mv debian/wesnoth-$(BRANCH_VERSION)/usr/share/metainfo/org.wesnoth.Wesnoth.appdata.xml \
		debian/wesnoth-$(BRANCH_VERSION)/usr/share/metainfo/org.wesnoth.Wesnoth-$(BRANCH_VERSION).appdata.xml
	# add branch name to desktop and metainfo entries
	sed -i -e "/^Name/ s/$$/ ($(BRANCH_VERSION))/" \
		debian/wesnoth-$(BRANCH_VERSION)/usr/share/applications/*.desktop
	sed -i -e "s/Wesnoth.desktop/Wesnoth-$(BRANCH_VERSION).desktop/" \
		debian/wesnoth-$(BRANCH_VERSION)/usr/share/metainfo/*.xml
	
	# /usr/share/doc symlinks
	for i in wesnoth-$(BRANCH_VERSION) ; do \
		install -p -d -m755 debian/$$i/usr/share/doc; \
		ln -s wesnoth-$(BRANCH_VERSION)-data debian/$$i/usr/share/doc/$$i; \
	done

execute_after_dh_install-indep:
	# workaround for dh_link (mis)behavior, see BTS#445550
	for i in dejavu/DejaVuSans.ttf dejavu/DejaVuSans-Bold.ttf dejavu/DejaVuSansMono.ttf dejavu/DejaVuSansMono-Bold.ttf dejavu/DejaVuSans-Oblique.ttf droid/DroidSansFallbackFull.ttf lato/Lato-Bold.ttf lato/Lato-Italic.ttf lato/Lato-Medium.ttf lato/Lato-MediumItalic.ttf lato/Lato-Light.ttf lato/Lato-LightItalic.ttf lato/Lato-Regular.ttf lato/Lato-BlackItalic.ttf lato/Lato-Black.ttf lato/Lato-BoldItalic.ttf lato/Lato-Bold.ttf lato/Lato-HairlineItalic.ttf lato/Lato-Hairline.ttf lato/Lato-HeavyItalic.ttf lato/Lato-Heavy.ttf lato/Lato-SemiboldItalic.ttf lato/Lato-Semibold.ttf lato/Lato-ThinItalic.ttf lato/Lato-Thin.ttf adf/OldaniaADFStd-BoldItalic.otf adf/OldaniaADFStd-Bold.otf adf/OldaniaADFStd-Italic.otf adf/OldaniaADFStd-Regular.otf lohit-bengali/Lohit-Bengali.ttf; \
		do ln -sf /usr/share/fonts/truetype/$$i \
	       	debian/wesnoth-$(BRANCH_VERSION)-data/usr/share/games/wesnoth/$(BRANCH_VERSION)/fonts/`basename $$i`; \
	done
	
	# rename icons versioned
	for i in 128x128/apps/wesnoth-icon.png 16x16/apps/wesnoth-icon.png 256x256/apps/wesnoth-icon.png 32x32/apps/wesnoth-icon.png 512x512/apps/wesnoth-icon.png 64x64/apps/wesnoth-icon.png; \
		do mv debian/wesnoth-$(BRANCH_VERSION)-data/usr/share/icons/hicolor/$$i \
		debian/wesnoth-$(BRANCH_VERSION)-data/usr/share/icons/hicolor/`dirname $$i`/wesnoth-$(BRANCH_VERSION)-icon.png; \
	done
	mv debian/wesnoth-$(BRANCH_VERSION)-data/usr/share/icons/HighContrast/scalable/apps/wesnoth-icon.svg \
		debian/wesnoth-$(BRANCH_VERSION)-data/usr/share/icons/HighContrast/scalable/apps/wesnoth-$(BRANCH_VERSION)-icon.svg
	
	# Drop data/tools/wesnoth_addon_manager (standalone client for addon devs to
	# upload/download WML content from addon server, no impact on in-game addon
